<?php

  /**
   * BaseJobType class
   *
   * @package activeCollab.modules.tracking
   * @subpackage models
   */
  abstract class BaseJobType extends ApplicationObject {
  
    /**
     * Name of the table where records are stored
     *
     * @var string
     */
    protected $table_name = 'job_types';
    
    /**
     * All table fields
     *
     * @var array
     */
    protected $fields = array('id', 'name', 'default_hourly_rate', 'is_default');
    
    /**
     * Primary key fields
     *
     * @var array
     */
    protected $primary_key = array('id');
    
    /**
     * Name of AI field (if any)
     *
     * @var string
     */
    protected $auto_increment = 'id';
    

    /**
     * Return value of id field
     *
     * @return integer
     */
    function getId() {
      return $this->getFieldValue('id');
    } // getId
    
    /**
     * Set value of id field
     *
     * @param integer $value
     * @return integer
     */
    function setId($value) {
      return $this->setFieldValue('id', $value);
    } // setId

    /**
     * Return value of name field
     *
     * @return string
     */
    function getName() {
      return $this->getFieldValue('name');
    } // getName
    
    /**
     * Set value of name field
     *
     * @param string $value
     * @return string
     */
    function setName($value) {
      return $this->setFieldValue('name', $value);
    } // setName

    /**
     * Return value of default_hourly_rate field
     *
     * @return float
     */
    function getDefaultHourlyRate() {
      return $this->getFieldValue('default_hourly_rate');
    } // getDefaultHourlyRate
    
    /**
     * Set value of default_hourly_rate field
     *
     * @param float $value
     * @return float
     */
    function setDefaultHourlyRate($value) {
      return $this->setFieldValue('default_hourly_rate', $value);
    } // setDefaultHourlyRate

    /**
     * Return value of is_default field
     *
     * @return boolean
     */
    function getIsDefault() {
      return $this->getFieldValue('is_default');
    } // getIsDefault
    
    /**
     * Set value of is_default field
     *
     * @param boolean $value
     * @return boolean
     */
    function setIsDefault($value) {
      return $this->setFieldValue('is_default', $value);
    } // setIsDefault

    /**
     * Set value of specific field
     *
     * @param string $name
     * @param mided $value
     * @return mixed
     */
    function setFieldValue($name, $value) {
      switch($real_name = $this->realFieldName($name)) {
        case 'id':
          return parent::setFieldValue($real_name, intval($value));
        case 'name':
          return parent::setFieldValue($real_name, strval($value));
        case 'default_hourly_rate':
          return parent::setFieldValue($real_name, floatval($value));
        case 'is_default':
          return parent::setFieldValue($real_name, boolval($value));
      } // switch
      
      throw new InvalidParamError('name', $name, "Field $name (maps to $real_name) does not exist in this table");
    } // switch
  
  }

